//-----------------------------------------------------------------------------
// Projet               : La physique amusante
// Class                : Elastique.pde
// Auteur               : Sylvain Blocquaux
// Date                 : 16 avril 2011
// Version              : 1.0
//-----------------------------------------------------------------------------

class Elastique {
  Noeud pointA;
  Noeud pointB;
  float longueurRepos; // longueur au repos en pixel
  float forceK = 10; // Constant de raideur en N.m-1
  int correction = 60; 

  Elastique(Noeud _pointA, Noeud _pointB, float _longueurRepos) {
    pointA = _pointA;
    pointB = _pointB;
    longueurRepos = _longueurRepos;
  }

  void calculForce() {
    PVector rappel = PVector.sub(pointB.position, pointA.position); // Vecteur du déplacement
    float longueur = rappel.mag();
    float etirement = longueur - longueurRepos; // Calcul de l'étirement
    if (etirement > 0) {
      rappel.normalize();
      rappel.mult((- 0.5) * forceK * etirement / correction); // Calcul de la force de rappel
      pointB.addForce(rappel);
      println(rappel);
      rappel.mult(-1); // Inverse la force
      pointA.addForce(rappel);
    }
  }

  void afficher() {
    line(pointB.position.x,  pointB.position.y, pointA.position.x,pointA.position.y);
  }
}

