//-----------------------------------------------------------------------------
// Projet               : La physique amusante
// Programme            : Pendule_2.pde
// Auteur               : Sylvain Blocquaux
// Date                 : 16 avril 2011
// Version              : 1.0
//-----------------------------------------------------------------------------

int deplacement = 200;
float delta;
ArrayList elastiques;
ArrayList noeuds;
int element = 12;
int taille = 100;
boolean flag = false;

void setup() {
  size(400, 800, P2D);
  smooth();
  frameRate(60);
  delta = 1 / frameRate;
  noeuds = new ArrayList();
  elastiques = new ArrayList();
  noeuds.add(new Noeud(0, new PVector(0, 0)));
  for (int i = 1; i < element; i++) {
    noeuds.add(new Noeud(0.01, new PVector(0, i * taille / element)));
    elastiques.add(new Elastique((Noeud) noeuds.get(i), (Noeud) noeuds.get(i - 1), taille / element));
  }
  noeuds.add(new Noeud(0.1, new PVector(0, element * taille / element)));
  elastiques.add(new Elastique((Noeud) noeuds.get(element), (Noeud) noeuds.get(element - 1), taille / element));
}

void draw() {
  background(255);
  translate(deplacement, deplacement);
  stroke(0);
  fill(100);
  rect(-25, -50, 50, 50);
  PVector souris = new PVector(mouseX, mouseY);
  Noeud extremite = (Noeud) noeuds.get(element);
  extremite.glisser(souris);
  for (int i = 0; i < element; i++) {
    Elastique elastique = (Elastique) elastiques.get(i);
    elastique.calculForce();
  }
  for (int i = 1; i <= element; i++) {
    Noeud noeud = (Noeud) noeuds.get(i);
    noeud.actualiser(delta);
  }
  for (int i = 0; i < element; i++) {
    Elastique elastique = (Elastique) elastiques.get(i);
    elastique.afficher();
  }
  extremite.afficher();
}

void mousePressed() {
  Noeud extremite = (Noeud) noeuds.get(element);
  extremite.selectionner(new PVector(mouseX, mouseY));
}

void mouseReleased() {
  Noeud extremite = (Noeud) noeuds.get(element);
  extremite.deSelectionner();
}

void keyPressed() {
  if (!flag) {
    noLoop();
    flag = true;
  } 
  else { 
     loop();
    flag = false;
  }
}

